unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  acClasses, acHTTP, StdCtrls, acMRUComboBox, acStatusControl, ComCtrls,
  acFormPlacementSaver, acAppStartCounter, ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    URLCombo: TacMRUComboBox;
    acStatusControl1: TacStatusControl;
    Label1: TLabel;
    Out1: TRadioButton;
    Out2: TRadioButton;
    GroupBox2: TGroupBox;
    Memo1: TMemo;
    acHTTP1: TacHTTP;
    Label2: TLabel;
    GroupBox3: TGroupBox;
    POSTEdit: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    acFormPlacementSaver1: TacFormPlacementSaver;
    StatusBar1: TStatusBar;
    ProgressBar1: TProgressBar;
    acAppStartCounter1: TacAppStartCounter;
    Panel1: TPanel;
    GOBtn: TButton;
    STOPBtn: TButton;
    procedure GOBtnClick(Sender: TObject);
    procedure STOPBtnClick(Sender: TObject);
    procedure acHTTP1Aborted(Sender: TObject);
    procedure acHTTP1ConnLost(Sender: TObject; ContentType: string;
      FileSize, BytesRead: Integer; Stream: TStream);
    procedure acHTTP1Done(Sender: TObject; ContentType: string;
      FileSize: Integer; Stream: TStream);
    procedure acHTTP1HostUnreachable(Sender: TObject);
    procedure acHTTP1HTTPError(Sender: TObject; ErrorCode: Integer;
      Stream: TStream);
    procedure acHTTP1PasswordRequest(Sender: TObject;
      var TryAgain: Boolean);
    procedure acHTTP1Progress(Sender: TObject; ContentType: string;
      FileSize, BytesRead, ElapsedTime, EstimatedTimeLeft: Integer;
      PercentsDone: Byte; TransferRate: Single; Stream: TStream);
    procedure acAppStartCounter1FirstStart(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.GOBtnClick(Sender: TObject);
begin
  acHTTP1.URL := URLCombo.Text;
  acHTTP1.POSTData := POSTEdit.Text;
  acHTTP1.Read;

  Memo1.Clear;
  ProgressBar1.Position := 0;
end;

procedure TForm1.STOPBtnClick(Sender: TObject);
begin
  acHTTP1.Abort;
end;

procedure TForm1.acHTTP1Aborted(Sender: TObject);
begin
  StatusBar1.Panels[0].Text := 'Connection aborted by user';
end;

procedure TForm1.acHTTP1ConnLost(Sender: TObject; ContentType: string;
  FileSize, BytesRead: Integer; Stream: TStream);
begin
  StatusBar1.Panels[0].Text := 'Connection with remote host lost';
end;

procedure TForm1.acHTTP1Done(Sender: TObject; ContentType: string;
  FileSize: Integer; Stream: TStream);
var
  Str: String;  
begin
  with Stream as TMemoryStream do
   if Out1.Checked then
    begin
     SetLength(Str, Size);
     Move(Memory^, Str[1], Size);
     Memo1.Text := Str;
    end
   else
    begin
     Memo1.Text := 'Saved to c:\httptest.dat';
     SaveToFile('c:\httptest.dat');
    end;
     
  StatusBar1.Panels[0].Text := 'Successfully downloaded ' + IntToStr(FileSize) + ' bytes';
end;

procedure TForm1.acHTTP1HostUnreachable(Sender: TObject);
begin
  StatusBar1.Panels[0].Text := 'Host unrechable';
end;

procedure TForm1.acHTTP1HTTPError(Sender: TObject; ErrorCode: Integer;
  Stream: TStream);
var
  Str: String;
begin
  with Stream as TMemoryStream do
   if Out1.Checked then
    begin
     SetLength(Str, Size);
     Move(Memory^, Str[1], Size);
     Memo1.Text := Str;
    end
   else
    begin
     Memo1.Text := 'Saved to c:\httptest.dat';
     SaveToFile('c:\httptest.dat');
    end;

  case ErrorCode of
    404: Str := '404: Document not found';
    500: Str := '500: CGI script failed';
    else
      Str := IntToStr(ErrorCode);
   end;

  StatusBar1.Panels[0].Text := 'HTTP Error #' + Str;
end;

procedure TForm1.acHTTP1PasswordRequest(Sender: TObject;
  var TryAgain: Boolean);
begin
  StatusBar1.Panels[0].Text := 'Password protected site';  
  { implement dialog which asks the username/password here }
// acHTTP1.Username := AskUsername;
// acHTTP1.Password := AskPassword;
// TryAgain := True;
end;

procedure TForm1.acHTTP1Progress(Sender: TObject; ContentType: string;
  FileSize, BytesRead, ElapsedTime, EstimatedTimeLeft: Integer;
  PercentsDone: Byte; TransferRate: Single; Stream: TStream);
begin
  ProgressBar1.Position := PercentsDone;
end;

procedure TForm1.acAppStartCounter1FirstStart(Sender: TObject);
begin
  URLCombo.Items.Add('http://www.appcontrols.com/cgi/test/http_test1.cgi');
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  URLCombo.Width := ClientWidth - 133;
end;

end.
 